# IntegrationService

> The IntegrationService methods and their request and response messages.

Source: https://engramsfactory.com/docs/api/integration/

Generated from [`integration.proto`](https://github.com/cortexapps/engrams/blob/main/crates/engram-protocol/proto/engram/app/v1/integration.proto). Every method is
`POST /rpc/engram.app.v1.IntegrationService/<Method>` with a JSON or protobuf body and an
`x-api-key` header.

## Methods

| Method | Request | Response |
|---|---|---|
| `ListConnectors` | [`ListConnectorsRequest`](#listconnectorsrequest) | [`ListConnectorsResponse`](#listconnectorsresponse) |
| `UpsertConnector` | [`UpsertConnectorRequest`](#upsertconnectorrequest) | [`UpsertConnectorResponse`](#upsertconnectorresponse) |
| `DeleteConnector` | [`DeleteConnectorRequest`](#deleteconnectorrequest) | [`DeleteConnectorResponse`](#deleteconnectorresponse) |
| `GetIntegrationCatalog` | [`GetIntegrationCatalogRequest`](#getintegrationcatalogrequest) | [`GetIntegrationCatalogResponse`](#getintegrationcatalogresponse) |
| `SetMintCredential` | [`SetMintCredentialRequest`](#setmintcredentialrequest) | [`SetMintCredentialResponse`](#setmintcredentialresponse) |
| `UploadConnectorLogo` | [`UploadConnectorLogoRequest`](#uploadconnectorlogorequest) | [`UploadConnectorLogoResponse`](#uploadconnectorlogoresponse) |
| `TestConnector` | [`TestConnectorRequest`](#testconnectorrequest) | [`TestConnectorResponse`](#testconnectorresponse) |
| `SetConnectorSettings` | [`SetConnectorSettingsRequest`](#setconnectorsettingsrequest) | [`SetConnectorSettingsResponse`](#setconnectorsettingsresponse) |
| `ListConnections` | [`ListConnectionsRequest`](#listconnectionsrequest) | [`ListConnectionsResponse`](#listconnectionsresponse) |
| `CreateConnection` | [`CreateConnectionRequest`](#createconnectionrequest) | [`CreateConnectionResponse`](#createconnectionresponse) |
| `UpdateConnection` | [`UpdateConnectionRequest`](#updateconnectionrequest) | [`UpdateConnectionResponse`](#updateconnectionresponse) |
| `DeleteConnection` | [`DeleteConnectionRequest`](#deleteconnectionrequest) | [`DeleteConnectionResponse`](#deleteconnectionresponse) |
| `TestConnection` | [`TestConnectionRequest`](#testconnectionrequest) | [`TestConnectionResponse`](#testconnectionresponse) |
| `SetConnectionEnabled` | [`SetConnectionEnabledRequest`](#setconnectionenabledrequest) | [`SetConnectionEnabledResponse`](#setconnectionenabledresponse) |
| `GetGoogleCloudSetup` | [`GetGoogleCloudSetupRequest`](#getgooglecloudsetuprequest) | [`GetGoogleCloudSetupResponse`](#getgooglecloudsetupresponse) |

## Messages

### CatalogCapability

| Field | Type |
|---|---|
| `action` | `string` |
| `access` | `string` |
| `asset` | `string` |
| `label` | `string` |
| `host` | `string` |
| `endpoint_rule` | `string` |

### Connector

| Field | Type |
|---|---|
| `provider` | `string` |
| `config_json` | `string` |
| `builtin` | `bool` |
| `created_at` | `string` |
| `updated_at` | `string` |
| `status` | `string` |
| `settings` | `map<string, string>` |

### ConnectorDisplay

| Field | Type |
|---|---|
| `name` | `string` |
| `category` | `string` |
| `blurb` | `string` |
| `icon` | [`ConnectorIcon`](#connectoricon) |
| `featured` | `bool` |

### ConnectorIcon

| Field | Type |
|---|---|
| `mono` | `string` |
| `color` | `string` |
| `logo` | `string` |

### CreateConnectionRequest

| Field | Type |
|---|---|
| `alias` | `string` |
| `provider` | `string` |
| `display_name` | `string` |
| `google_cloud` | [`GoogleCloudConnectionConfig`](#googlecloudconnectionconfig) |

### CreateConnectionResponse

| Field | Type |
|---|---|
| `connection` | [`IntegrationConnection`](#integrationconnection) |

### DeleteConnectionRequest

| Field | Type |
|---|---|
| `id` | `string` |

### DeleteConnectionResponse

| Field | Type |
|---|---|
| `deleted` | `bool` |

### DeleteConnectorRequest

| Field | Type |
|---|---|
| `provider` | `string` |

### DeleteConnectorResponse

| Field | Type |
|---|---|
| `deleted` | `bool` |

### GetGoogleCloudSetupRequest

| Field | Type |
|---|---|
| `id` | `string` |

### GetGoogleCloudSetupResponse

| Field | Type |
|---|---|
| `issuer` | `string` |
| `audience` | `string` |
| `subject_attribute` | `string` |
| `connection_attribute` | `string` |
| `gcloud_script` | `string` |
| `terraform` | `string` |

### GetIntegrationCatalogRequest

No fields.

### GetIntegrationCatalogResponse

| Field | Type |
|---|---|
| `providers` | repeated [`ProviderCatalogEntry`](#providercatalogentry) |

### GoogleCloudConnectionConfig

| Field | Type |
|---|---|
| `workload_identity_provider` | `string` |
| `service_account_email` | `string` |
| `endpoints` | repeated `string` |
| `cloud_sql_postgres_instance` | `string` |

### IntegrationConnection

| Field | Type |
|---|---|
| `id` | `string` |
| `alias` | `string` |
| `provider` | `string` |
| `display_name` | `string` |
| `enabled` | `bool` |
| `tested_at` | `string` |
| `created_at` | `string` |
| `updated_at` | `string` |
| `google_cloud` | [`GoogleCloudConnectionConfig`](#googlecloudconnectionconfig) |
| `is_default` | `bool` |

### ListConnectionsRequest

No fields.

### ListConnectionsResponse

| Field | Type |
|---|---|
| `connections` | repeated [`IntegrationConnection`](#integrationconnection) |

### ListConnectorsRequest

No fields.

### ListConnectorsResponse

| Field | Type |
|---|---|
| `connectors` | repeated [`Connector`](#connector) |

### ProviderCatalogEntry

| Field | Type |
|---|---|
| `provider` | `string` |
| `display` | [`ConnectorDisplay`](#connectordisplay) |
| `credential_source` | `string` |
| `hosts` | repeated `string` |
| `capabilities` | repeated [`CatalogCapability`](#catalogcapability) |
| `default_connection_id` | `string` |
| `connection_model` | `string` |
| `user_credential` | [`UserCredentialSupport`](#usercredentialsupport) |

### SetConnectionEnabledRequest

| Field | Type |
|---|---|
| `id` | `string` |
| `enabled` | `bool` |

### SetConnectionEnabledResponse

| Field | Type |
|---|---|
| `connection` | [`IntegrationConnection`](#integrationconnection) |

### SetConnectorSettingsRequest

| Field | Type |
|---|---|
| `provider` | `string` |
| `settings` | `map<string, string>` |

### SetConnectorSettingsResponse

| Field | Type |
|---|---|
| `connector` | [`Connector`](#connector) |

### SetMintCredentialRequest

| Field | Type |
|---|---|
| `provider` | `string` |
| `kind` | `string` |
| `values` | `map<string, string>` |

### SetMintCredentialResponse

| Field | Type |
|---|---|
| `secret_names` | repeated `string` |

### TestConnectionRequest

| Field | Type |
|---|---|
| `id` | `string` |

### TestConnectionResponse

| Field | Type |
|---|---|
| `ok` | `bool` |
| `message` | `string` |

### TestConnectorRequest

| Field | Type |
|---|---|
| `provider` | `string` |
| `draft_values` | `map<string, string>` |
| `draft_settings` | `map<string, string>` |

### TestConnectorResponse

| Field | Type |
|---|---|
| `ok` | `bool` |
| `message` | `string` |

### UpdateConnectionRequest

| Field | Type |
|---|---|
| `id` | `string` |
| `alias` | `string` |
| `display_name` | `string` |
| `google_cloud` | [`GoogleCloudConnectionConfig`](#googlecloudconnectionconfig) |

### UpdateConnectionResponse

| Field | Type |
|---|---|
| `connection` | [`IntegrationConnection`](#integrationconnection) |

### UploadConnectorLogoRequest

| Field | Type |
|---|---|
| `provider` | `string` |
| `data` | `bytes` |
| `media_type` | `string` |

### UploadConnectorLogoResponse

| Field | Type |
|---|---|
| `logo_url` | `string` |

### UpsertConnectorRequest

| Field | Type |
|---|---|
| `config_json` | `string` |

### UpsertConnectorResponse

| Field | Type |
|---|---|
| `connector` | [`Connector`](#connector) |

### UserCredentialSupport

| Field | Type |
|---|---|
| `oauth` | `bool` |
| `token` | `bool` |
| `token_hint` | `string` |
